#if !defined(__MY_DATA_hxx__)
#define __MY_DATA_hxx__

#include "TTree.h"

#define memorydepth 100

class MY_DATA {
public:
  Double_t peak;
  Int_t selection;
  Int_t npts;
  Double_t wvf[(memorydepth)]; // [npts]
  
  MY_DATA();
  void Branch(TTree *tree, const char *prefix = "");
  void SetBranchAddress(TTree *tree, const char *prefix = "");
};

MY_DATA::MY_DATA() {
  peak = 0.;
  selection = 0;
  npts = 0;
  for(Int_t i = 0; i < (memorydepth); i++) wvf[i] = 0.;
}

void MY_DATA::Branch(TTree *tree, const char *prefix) {
  if (!tree) return; // just a precaution
  if (!prefix) prefix = ""; // just a precaution
  tree->Branch(Form("%speak", prefix), &peak);
  tree->Branch(Form("%sselection", prefix), &selection);
  tree->Branch(Form("%snpts", prefix), &npts);
  tree->Branch(Form("%swvf", prefix), wvf, Form("%swvf[%snpts]/D", prefix, prefix));
}

void MY_DATA::SetBranchAddress(TTree *tree, const char *prefix) {
  if (!tree) return; // just a precaution
  if (!prefix) prefix = ""; // just a precaution
  tree->SetBranchAddress(Form("%speak", prefix), &peak);
  tree->SetBranchAddress(Form("%sselection", prefix), &selection);
  tree->SetBranchAddress(Form("%snpts", prefix), &npts);
  tree->SetBranchAddress(Form("%swvf", prefix), wvf);
}

#endif /* !defined(__MY_DATA_hxx__) */
